﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip


Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private btnOpen As Button
	Private cmbPort As ComboBox
	Private lblStatus As Label
	Private txtInput As TextArea
	Private txtLog As TextField
	Private sp As Serial
	Private astream As AsyncStreams
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	sp.Initialize("")
	cmbPort.Items.AddAll(sp.ListPorts)
End Sub


Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'You can see the list of page related events in the B4XPagesManager object. The event name is B4XPage.

Sub cmbPort_SelectedIndexChanged(Index As Int, Value As Object)
	btnOpen.Enabled = Index > -1 'enable the button if there is a selected item
End Sub

Sub btnOpen_Action
	sp.Open(cmbPort.Value)
	astream.InitializePrefix(sp.GetInputStream, True, sp.GetOutputStream, "astream")
	sp.SetParams(9600,8,1,0)
	txtInput.Enabled = True
	btnOpen.Enabled = False
	lblStatus.Text = "Status: Open"
End Sub

Sub MainForm_Closed
	sp.Close
End Sub

Sub AStream_NewData (Buffer() As Byte)
	Dim s As String = BytesToString(Buffer, 0, Buffer.Length, "UTF8")
	LogMessage("You", s)
End Sub

Sub txtInput_Action
	astream.Write(txtInput.Text.GetBytes("UTF8"))
	txtInput.SelectAll
	txtInput.RequestFocus
	LogMessage("Me", txtInput.Text)
End Sub

Sub LogMessage(From As String, Msg As String)
	txtLog.Text = txtLog.Text & From & ": " & Msg & CRLF
	txtLog.SetSelection(txtLog.Text.Length, txtLog.Text.Length)
End Sub

Sub AStream_Error
	Log("Error: " & LastException)
	astream.Close
	AStream_Terminated
End Sub

Sub AStream_Terminated
	Log("Connection is broken.")
	lblStatus.Text = "Status: Close"
	txtInput.Enabled = False
	btnOpen.Enabled = True
End Sub

Sub txtInput_enterpressed (Old As String, New As String)
	astream.Write(txtInput.Text.GetBytes("UTF8"))
	txtInput.SelectAll
	txtInput.RequestFocus
	LogMessage("Me", txtInput.Text)
End Sub

